(* Syntax.topdef list -> Syntax.t *)

open Syntax

let f lst =
  List.fold_right
    (fun def e -> match def with
     | Defvar(xs,body) -> Let((xs,body),e)
     | Defun(x,ys,body) -> LetRec((x,ys,body),e))
    lst Unit
