(* ネストした演算を許さない
   変数には string のかわりに Id.t を使う *)
(* おおむね型推論の準備 *)

type t =
| Let of Id.t list * t * t
| LetRec of Id.t * Id.t list * t * t
| If of operand * t * t
| Op of operand * operand list
| Tuple of operand list
| V of operand
and operand =
| Unit
| Int of int
| Float of float
| Bool of bool
| Var of Id.t
