(* float (1) *)
let rec fequal x y = x = y +. 0.0
let rec fless x y = x <= y +. 0.0

let rec fispos x = x > 0.0
let rec fisneg x = x < 0.0
let rec fiszero x = x = 0.0

(* logic *)
let rec not x = if x then false else true
let rec xor x y = if x then not y else y

(* float (2) *)
let rec fhalf x = x *. 0.5
let rec fsqr x = x *. x

let rec fabs x = if x < 0.0 then -.x else x
let rec fneg x = -.x

(* mada *)
let rec int_of_float x = let _ = x +. 0.0 in 0
let rec float_of_int x = let _ = x + 0 in 0.0

let rec cos x = x +. 0.0
let rec sin x = x +. 0.0
let rec atan x = x +. 0.0

(* I/O *)

let print_int = print_char

let rec read_int _ =
  let a = read_char () in
  let a = a + lsl (read_char ()) 8 in
  let a = a + lsl (read_char ()) 8 in
  a + lsl (read_char ()) 8

let rec read_float _ =
  let a = read_int () in
  float_of_bits a
