(* クロージャ変換前の最適化 *)
(* あんまりインライン展開しない *)

let rec g limit e =
  Format.eprintf "opt 1, rest %d@." limit;
  if limit <= 0 then e
  else let e_ =
    Elim.f (Arith.f (ConstFold.f (ConstProp.f (FlatLet.f (Inline.f e)))))
  in
  if compare e e_ = 0 then e_ else g (limit - 1) e_

let f limit e =
  let th = !Inline.threshold in
  Inline.threshold := 2;
  let ret = g limit e in
  Inline.threshold := th;
  ret
