(* Set + α *)

module Make (Elt : Set.OrderedType) = struct
  include Set.Make(Elt)

  let add x s = add x (remove x s)
  let add_list lst s = List.fold_left (fun s x -> add x s) s lst
  let of_list lst = add_list lst empty
  let remove_list lst s = List.fold_left (fun s x -> remove x s) s lst
end
