(* クロージャ変換後の最適化その1 *)

open Global

let rec f limit e =
  Format.eprintf "opt 2, rest %d@." limit;
  if limit <= 0 then e
  else let gl_bak = !gl_funs in
  let e_ =
    Elim.f
      (SideEffect.f
         (Arith.f
            (ConstFold.f
               (ConstProp.f
                  (FlatLet.f
                     (Inline.f
                        (TailIf.f e)))))))
  in
  if SameExp.f e e_ &&
    List.for_all2 (fun { name = x; body = e1 } { name = y; body = e2 } ->
      x = y && SameExp.f e1 e2)
      gl_bak !gl_funs
  then e_
  else f (limit - 1) e_
