(* クロージャ変換後の最適化その2 *)

open Global

let rec f limit e =
  Format.eprintf "opt 3, rest %d@." limit;
  if limit <= 0 then e
  else let gl_bak = !gl_funs in
  let e_ =
    Elim.f
      (SideEffect.f
         (Arith.f
            (ConstFold.f (ConstProp.f (FlatLet.f (Inline.f e))))))
  in
  gl_funs := List.sort (fun x y -> String.compare x.name y.name) !gl_funs;
  if compare e e_ = 0 && compare gl_bak !gl_funs = 0
  then e_ else f (limit - 1) e_
