(* 型の型 *)

type t =
| Tunit
| Tint
| Tfloat
| Tbool
| Tfun of t list * t
| Tarray of t
| Ttuple of t list
| Tvar of tv
| ForAll of tv list * t
and tv = t option ref

let new_tv () = ref None
let new_type () = Tvar(new_tv ())
